<?php

function display_direct_purchase_receipt_header_details($rcp_no, $rtn_no) {
    global $approval_statuses, $systypes_array;
    
    $rcp_hd_row = get_quality_check_header($rcp_no);
    
    $user_id = $_SESSION['wa_current_user']->user;
    $cap = can_access_project($rcp_hd_row['project_id'], $user_id);
        if ($cap['success'] !== true) {
            display_error($cap["message"]);
            display_footer_exit();
            exit;
        }
    
    display_heading($systypes_array[ST_DIRECT_PURCHASE_RECEIPT]." Header");
    
        $rcp_trans_no = $rcp_hd_row['trans_no'];
        if (! isset($_POST['location']) && ! ($rtn_no > 0)) {
            $_POST['location'] = $rcp_hd_row['loc_code'];
        }
    
    start_outer_table(TABLESTYLE2, "width=65%"); // outer table
        start_table(TABLESTYLE2);  
            table_section(1, "27%");
                $jo_id = $rcp_hd_row['jo_id'];
                if ($jo_id > 0) {
                    label_row(_("Job Card #:"), get_service_trans_view_str(ST_JOB_ORDER, $jo_id));
                } else {
                    label_row("Job Card #:", 'Purchase to Stock'); 
                }
                label_row("GRN Trans #:", get_supplier_trans_view_str($rcp_hd_row['type'], $rcp_hd_row['trans_no']));  

            table_section(2, "45%");
                label_row("Reference:", $rcp_hd_row['reference']);  
                label_row("Project:", get_project_formatted_name($rcp_hd_row['project_id']));  
                label_row("Date:", sql2date($rcp_hd_row['tran_date']));  
                
            table_section(3, "27%");
                label_row("Location:", $rcp_hd_row['location_name']);  
                label_row("Requestor:", $rcp_hd_row['requestor_name']);  
                $s = get_project_trans_view_str(ST_APPROVAL_LOG, $rcp_trans_no."&source_type_id=".ST_DIRECT_PURCHASE_RECEIPT, "Approval Status");
                label_row($s, $approval_statuses[$rcp_hd_row['approval_status']]);

    end_outer_table(2); // outer table
    
    if (strlen($rcp_hd_row['comments']) > 0) {
        start_table(TABLESTYLE);
            label_row("Comments:", nl2br($rcp_hd_row['comments']));  
        end_table(2);
    }
    
    return $rcp_hd_row;
}

function display_direct_purchase_return_header($rtn_no, $rcp_hd_row) {
    global $Refs, $systypes_array;
    
    display_heading($systypes_array[ST_DIRECT_PURCHASE_RETURN]." Header");
    
        $type = ST_DIRECT_PURCHASE_RETURN;
        $trans_no = 0;
    
        $_POST['project_id'] = $rcp_hd_row['project_id'];
        hidden('project_id', $rcp_hd_row['project_id']);

        $user_id = $_SESSION['wa_current_user']->user;
        $cap = can_access_project($_POST['project_id'], $user_id);
            if($cap['success'] !== true) {
                display_error($cap["message"]);
                set_focus('project_id');
                display_footer_exit();
                exit;
            }  
            
        $header = get_quality_check_header($rtn_no);

        if (is_array($header)) {
            
            $trans_no = $header['trans_no'];

            if (! isset($_POST['reference'])) {
                $_POST['reference'] = $header['reference'];
            }

            if (! isset($_POST['comments'])){
                $_POST['comments'] = $header['comments'];
            }        

            if (! isset($_POST['location'])) {
                $_POST['location'] = $header['loc_code'];
            }

            if (! isset($_POST['tran_date'])) {
                $_POST['tran_date'] = sql2date($header['tran_date']);
            }

            if (! isset($_POST['approval_status'])) {
                $_POST['approval_status'] = $header['approval_status'];
            }

        } else {
            $_POST['reference'] = $Refs->get_next($type);            
            $_POST['approval_status'] = 0;
        }
        
        div_start('nsit_header');
  
            start_outer_table(TABLESTYLE2, "width=65%"); // outer table
                start_table(TABLESTYLE2);  
                    table_section(1, "50%");

                        if (is_array($header)) {
                            label_row("Trans #:", get_supplier_trans_view_str($header['type'], $header['trans_no']));  
                            
                            $reference = $header['reference'];            
                            text_row("Reference:", 'reference', $reference, null, null);            
                        } else {            
                            text_row("Reference:", 'reference', $Refs->get_next($type), null, null);   
                        }
                        
                        date_row("Date:", "tran_date");
                        if (is_array($header)) {
                            label_row("Return Location:", $header['location_name']); 
                            hidden('location', $_POST['location']);
                        } else {
                            locations_list_row("Return Location:", 'location', null, '', false); 
                        }

                    table_section(2, "50%");
                        
                        textarea_row("Comment:", 'comments', null, 35, 2); 

                        global $approval_statuses;
                        $s = get_project_trans_view_str(ST_APPROVAL_LOG, $trans_no."&source_type_id=".$type, "Approval Status");
                        label_row($s, $approval_statuses[$_POST['approval_status']]);

            end_outer_table(2); // outer table
    
        div_end();
}

function display_direct_purchase_return_details($rcp_no, $rtn_no) { 
    global $Ajax, $daily_item_types_array, $systypes_array;
    
    display_heading($systypes_array[ST_DIRECT_PURCHASE_RETURN]." Details");
    
    $rcp_trans_no = $trans_no = 0;
    $rcp_header = get_quality_check_header_record($rcp_no);
        if (is_array($rcp_header)) {
            $rcp_trans_no = $rcp_header['trans_no'];
        } 
        
    $rcp_hd_row = get_quality_check_header_record($rtn_no);
        if (is_array($rcp_hd_row)) {
            $trans_no = $rcp_hd_row['trans_no'];
        } 
        
    $units_array = build_all_item_units_array();
    
    $Ajax->activate('nsit_details');
    div_start('nsit_details');
    
        start_table(TABLESTYLE, "width=99%");

            $th = array(_("GRN Line"), _("Return Line"), _("Item Type"), _("Item"), _("GRN Unit"), _("GRN Qty"), _('Returned'), _('Returned Alloc'), _('Returned + Ret.Alloc'), 
                        _('Remain'), _('Return Unit'), _('Return.Qty'), _('Site'), _('Line Comment'), _("Lot Selec."), _("")); 
            
            table_header($th);

            $k = 0; //row colour counter
                $result = get_direct_purchase_receipt_with_direct_purchase_return_details($rcp_trans_no, $trans_no);      
                    while ($row = db_fetch($result)) {
                        $id = $row['trans_id'];
                        $rtn_line_id = $row['rtn_line_id'];
                        $rcp_conversion_factor = $row['conversion_factor'];
                        
                        alt_table_row_color($k);

                            label_cell(text_bold($id), 'align=center');
                            label_cell($rtn_line_id, 'align=center');
                            label_cell($daily_item_types_array[$row['item_type']]);
                            if ($row['item_type'] == NSIT_NON_STOCK_ITEM || $row['item_type'] == NSIT_STOCK_ITEM) {
                                label_cell($row["stock_id"]." - ".$row["item_description"]);  
                            } else {
                                label_cell($row["item_description"]);
                            }
                            label_cell($row["unit_name"]);
                            
                            $dec = 4;
                            qty_cell($row["tran_qty"], false, $dec);
                            qty_cell($row["returned_quantity"] / $rcp_conversion_factor, false, $dec);
                            qty_cell($row["returned_alloc"] / $rcp_conversion_factor, false, $dec);
                            qty_cell($row["returned_quantity"] + $row["returned_alloc"] / $rcp_conversion_factor, false, $dec);
                            qty_cell($row["tran_qty"] - ($row["returned_quantity"] + $row["returned_alloc"]) / $rcp_conversion_factor, false, $dec);
                            
                            if (! isset($_POST["return_tran_unit_$id"])) {
                                if ($rtn_line_id > 0) {
                                    $_POST["return_tran_unit_$id"] = $row["return_tran_unit"];
                                } else {
                                    $_POST["return_tran_unit_$id"] = $row["tran_unit"];
                                }
                            }
                            
                            if ($row['item_type'] == NSIT_NON_STOCK_ITEM || $row['item_type'] == NSIT_STOCK_ITEM) {
                                units_list_cells('', "return_tran_unit_$id", $row['stock_id'], null, '', true);
                            } else {
                                custom_values_list_cells('', "return_tran_unit_$id", $units_array, null, '', true);   
                            }
                            
                            if (! isset($_POST["return_tran_qty_$id"])) {
                                if ($rtn_line_id > 0) {
                                    $_POST["return_tran_qty_$id"] = $row["return_tran_qty"];
                                } else {
                                    set_direct_purchase_return_remain_acceptable_qty($id, $row, $dec);
                                }
                            } else {
                                if (list_updated("return_tran_unit_$id")) {
                                    set_direct_purchase_return_remain_acceptable_qty($id, $row, $dec);
                                }
                            }
                            amount_cells("", "return_tran_qty_$id", null, null, null, $dec);
                            
                            label_cell($row["site_description"]);          
                            label_cell(nl2br($row["line_comment"])); 
                            
                            if ($rtn_line_id > 0 && $row['stock_control_method'] == SKCM_LOTS) {
                                $rcp_convesion_factor = 1;
                                get_convertion_factor2($row["stock_id"], $_POST["return_tran_unit_$id"], $rcp_convesion_factor);
                                
                                display_lot_serial_edit_cells($row['stock_control_method'], ST_DIRECT_PURCHASE_RETURN, $trans_no, $rtn_line_id, $rcp_convesion_factor, $dec);
                            } else {
                                label_cell('');
                            }
                            
                            if (! isset($_POST["checked_$id"]) && $rtn_line_id > 0) {
                                $_POST["checked_$id"] = 1;
                            } 
                            check_cells(null, "checked_$id", null, false, false, 'align=center');

                        end_row();        
                    }

        end_table(3);
    
    div_end();
}

function set_direct_purchase_return_remain_acceptable_qty($id, $row, $dec=2) {
    $convesion_factor = 1;
    get_convertion_factor2($row['stock_id'], $_POST["return_tran_unit_$id"], $convesion_factor);

    $remain_tran_qty = ($row["qty"] - ($row["returned_quantity"] + $row["returned_alloc"])) / $convesion_factor;

    $_POST["return_tran_qty_$id"] = number_format($remain_tran_qty, $dec);
}

function can_save_direct_purchase_return_header($rcp_no, $rtn_no) {
    global $Refs, $systypes_array;
    
    $rcp_hd = get_quality_check_header_record($rcp_no);
        if (is_array($rcp_hd) && $rtn_no > 0) {
            if (! in_array($rcp_hd['approval_status'], array(AS_APPROVED, AS_COMPLETED))) {
                return array("success" => false, "message" => $systypes_array[ST_DIRECT_PURCHASE_RECEIPT]." #$rcp_no is not approved/completed.");
            }
        } elseif (is_array($rcp_hd)) {
            if (! in_array($rcp_hd['approval_status'], array(AS_APPROVED))) {
                return array("success" => false, "message" => $systypes_array[ST_DIRECT_PURCHASE_RECEIPT]." #$rcp_no is not approved.");
            }
        } else {
            return array("success" => false, "message" => $systypes_array[ST_DIRECT_PURCHASE_RECEIPT]." #$rcp_no has been deleted by another user.");
        }
    
    $trans_no = $rtn_row_state = 0;
    $rcp_row_state = $rcp_hd['row_state'];
    $header = get_quality_check_header_record($rtn_no);
    
    if (($rtn_no > 0) && ! is_array($header)) {
        return array("success" => false, "message" => $systypes_array[ST_DIRECT_PURCHASE_RETURN]." #$rtn_no has been deleted by another user.");
    }
      
    if ($rtn_no > 0) {
        if (! in_array($header['approval_status'], array(AS_NEW, AS_WITH_THE_APPROVER, AS_AWAITING_APPROVAL, AS_BACK_TO_ORIGINATOR))) {
            return array("success" => false, "message" => "This document status does not allow further updating.");
        }
        
        $ced_msg = can_edit_document($header['type'], $header['project_id'], $header['next_approval_group_id'], $_SESSION['wa_current_user']->user, $header['created_by']);
            if ($ced_msg['success'] !== true) {
                return array("success" => false, "message" => $ced_msg['message']);
            }
        
        $trans_no = $header['trans_no']; $rtn_row_state = $header['row_state'];
    }
    
    if (! $Refs->is_valid($_POST['reference'])) {
        return array("success" => false, "focus_to" => 'reference', "message" => "Please enter a reference.");      
    }    
 
    $ref_msg = reference_exists($_POST['reference'], ST_DIRECT_PURCHASE_RETURN, $trans_no);
        if ($ref_msg) {
            return array("success" => false, "focus_to" => 'reference', "message" => $ref_msg);       
        }
      
    if (! is_date($_POST['tran_date'])) {
        return array("success" => false, "focus_to" => 'tran_date', "message" => "Date entered is not a valid date.");        
    }
      
    if ($_POST['location'] == '') {
        return array("success" => false, "focus_to" => 'location', "message" => "Issuing location cannot empty.");
    }
    
    return array("success" => true, 'rcp_row_state' => $rcp_row_state, 'rtn_row_state' => $rtn_row_state, "message" => "");    
}

function can_save_direct_purchase_return_lines($rcp_trans_no, $trans_no, $type, $loc_code, $process=false) {
    global $systypes_array;
    
    $result = get_direct_purchase_receipt_with_direct_purchase_return_details($rcp_trans_no, $trans_no);  
        if (! (db_num_rows($result) > 0)) {
            return array('success' => false, 'message' => "No source ".$systypes_array[ST_DIRECT_PURCHASE_RECEIPT]." found.");
        }
        
        $check_exceeded_only = $process === false ? true : false;
        
        while ($row = db_fetch($result)) {
            $id = $row['trans_id'];
            $rtn_line_id = $row['rtn_line_id'];
            $stock_id = $row['stock_id'];
            
            if (isset($_POST["checked_$id"]) && $_POST["checked_$id"] == 1) {
                $item_type = $row['item_type'];
                
                $rtn_tran_unit = $_POST["return_tran_unit_$id"];
                $rtn_tran_qty = input_num("return_tran_qty_$id");
                
                $convesion_factor = 1;
                
                // can save direct purchase return line
                $cn_sv_ln = can_save_direct_purchase_return_line($trans_no, $stock_id, $loc_code, $item_type, $rtn_tran_unit, $rtn_tran_qty, $convesion_factor, $rtn_line_id, 
                                                                 $id, $row, $check_exceeded_only);
                    if ($cn_sv_ln['success'] !== true) {
                        return array("success" => false, "message" => $cn_sv_ln['message']);
                    }
                    
            } else {
                
                if ($rtn_line_id > 0) {
                    $lot_row = get_lot_allocation_records($type, $trans_no, $rtn_line_id, fetch:true);
                        if (is_array($lot_row) > 0) {
                            $lot_alloc_name = $systypes_array[ST_LOT_ALLOCATION];
                            return array("success" => false, "focus_to" => '',  
                                         "message" => "Please delete all $lot_alloc_name details in ".$systypes_array[$type]." Return Line #$rtn_line_id.");
                        }
                }
            }
        }
        
        return array("success" => true, "message" => "");
}

function can_save_direct_purchase_return_line($trans_no, $stock_id, $loc_code, $item_type, $rtn_tran_unit, $rtn_tran_qty, $convesion_factor, $rtn_line_id, $id, $row, 
                                              $check_exceeded_only=true) {
    $type = ST_DIRECT_PURCHASE_RETURN;
    $dec = get_qty_dec($stock_id);
    
        if ($item_type == NSIT_NON_STOCK_ITEM || $item_type == NSIT_STOCK_ITEM) {
            if ($rtn_tran_unit == -1) {
                return array("success" => false, "focus_to" => "return_tran_unit_$id", "message" => "GRN Line #$id Please select a tran unit.");  
            }
        } elseif ($item_type == NSIT_COMMENT) {
            if ($rtn_tran_unit == '0') {
                return array("success" => false, "focus_to" => "return_tran_unit_$id", "message" => "GRN Line #$id  Please select an unit.");  
            }
        }

        if (! ($rtn_tran_qty > 0)) {
            return array("success" => false, "focus_to" => "return_tran_qty_$id", "message" => "GRN Line #$id Qty should be greater than zero.");  
        }

        get_convertion_factor2($stock_id, $rtn_tran_unit, $convesion_factor);
        
        $rcp_base_qty = (float) $row['qty'];

        $base_rcpd_qty = (float) get_quality_check_lines_total_by_source_line($type, $id, $rtn_line_id);
        $tran_rcpd_qty = $base_rcpd_qty / $convesion_factor;

        $total_tran_rcpd_qty = round($tran_rcpd_qty + $rtn_tran_qty, $dec);

        $rcp_this_tran_qty = round($rcp_base_qty / $convesion_factor, $dec);

        if ($total_tran_rcpd_qty > $rcp_this_tran_qty) {
            $total_issuable_tran_qty = round($rcp_this_tran_qty - $tran_rcpd_qty, $dec);

            return array("success" => false, "focus_to" => "return_tran_qty_$id", 
                         "message" => "GRN Line #$id exceeded the maximum issuable Qty of $total_issuable_tran_qty for selected unit.");  
        }

        // check lot allocation exceeded
        if ($row['stock_control_method'] == SKCM_LOTS && $rtn_line_id > 0) {
            $data_arr = array('type' => $type, 'trans_no' => $trans_no, 'line_id' => $rtn_line_id, 'stock_id' => $stock_id, 'loc_code' => $loc_code, 
                              'conversion_factor' => $convesion_factor, 'tran_qty' => $rtn_tran_qty, 'tran_unit' => $rtn_tran_unit);
            $lot_ex_msg = check_total_lot_allocations_item_qty_exceed_allowable_qty($data_arr, $check_exceeded_only);
                if ($lot_ex_msg['success'] === false) {
                    if ($lot_ex_msg['exceeded'] === true) {
                        return array("success" => false, "message" => "Return line #$rtn_line_id Return Qty cannot smaller than total lot allcations."); 
                    } else {
                        return array("success" => false, "message" => "Return line #$rtn_line_id Return Qty cannot greater than total lot allcations."); 
                    }
                }
        }
                
        return array("success" => true, "focus_to" => "", "message" => ""); 
}

function save_direct_purchase_return_lines($rcp_trans_no, $trans_no, $project_id, $tran_date, $loc_code, $process=false, $rtn_approval_status=0) {
    global $systypes_array;
    $type = ST_DIRECT_PURCHASE_RETURN;
    
    $no_selected_recs = 0;
    $result = get_direct_purchase_receipt_with_direct_purchase_return_details($rcp_trans_no, $trans_no);  
    
    $rcp_lines_count = get_quality_check_details_lines_count($trans_no, $type);
        if ($rcp_lines_count > 0) {
            $del_af_rows = delete_quality_check_detail_lines($type, $trans_no);
                if ($del_af_rows != $rcp_lines_count) {
                    cancel_transaction();
                    return array('success' => false, 'message' => "Could not delete ".$systypes_array[$type]." detail lines.");
                }
        }
        
        while ($row = db_fetch($result)) {
            $id = $row['trans_id'];
            $rtn_line_id = $row['rtn_line_id'];
            
            if (isset($_POST["checked_$id"]) && $_POST["checked_$id"] == 1) {
                
                $rtn_tran_unit = $_POST["return_tran_unit_$id"];
                $rtn_tran_qty = input_num("return_tran_qty_$id");
                
                $convesion_factor = 1;
                
                // save direct purchase return line
                $sv_ln_msg = save_direct_purchase_return_line($type, $trans_no, $rtn_tran_unit, $rtn_tran_qty, $convesion_factor, $row);
                    if ($sv_ln_msg['success'] !== true) {
                        cancel_transaction();
                        return array("success" => false, "message" => $sv_ln_msg['message']);
                    }
                    
                // process direct purchase return line 
                if ($process === true && $rtn_approval_status == AS_APPROVED) {
                    $stock_control_method = $row['stock_control_method'];
                    
                    $prs_msg = process_direct_purchase_return_line($type, $trans_no, $tran_date, $project_id, $loc_code, $rtn_line_id, $stock_control_method);
                        if ($prs_msg['success'] !== true) {
                            cancel_transaction();
                            return array("success" => false, "message" => $prs_msg['message']);
                        }
                } 
                
                $no_selected_recs++;
            } 
        }
        
        if (! ($no_selected_recs > 0)) {
            cancel_transaction();
            return array("success" => false, "message" => "Please select at least one record before saving.");  
        }
        
        return array("success" => true, "message" => "");  
}

function save_direct_purchase_return_header(&$rcp_no, &$rtn_no, &$trans_no, $type, $project_id, $loc_code, $tran_date, $rtn_row_state) {
    global $systypes_array;
    
    $dpr_hd_row = get_quality_check_header_record($rcp_no);
        $jo_id = $dpr_hd_row['jo_id'];
        
        $af_no = write_quality_check_header($jo_id, $type, $rcp_no, $rtn_no, $trans_no, $_POST['reference'], $project_id, $loc_code, $_POST['comments'], $tran_date, 
                                            $rtn_row_state); 

            if ($af_no > 0) {
                return array("success" => true, "message" => $systypes_array[$type]." header record #$rtn_no has been saved.");
            } else {
                return array("success" => false, "message" => "Could not be saved ".$systypes_array[$type].' header.');
            }
}

function save_direct_purchase_return_line($type, $trans_no, $tran_unit, $tran_qty, $conversion_factor, $row) {    
    global $systypes_array;
    
        $id = $row['trans_id'];
        $rtn_line_id = $row['rtn_line_id'];

        $stock_id = $row['stock_id'];
        $item_type = $row['item_type'];
        $item_description = $row['item_description'];
        $standard_cost = $row['standard_cost'];
        $project_site_id = $row['project_site_id'];
        $line_comment = $row['line_comment'];
        $task_id = $row['task_id'];
                
            if ($item_type == NSIT_STOCK_ITEM) {
                $standard_cost = get_standard_cost($stock_id);
            } 
            
            get_convertion_factor2($stock_id, $tran_unit, $conversion_factor);

            $base_qty = $tran_qty * $conversion_factor;
            
            $ln_id = insert_quality_check_line($trans_no, $type, $stock_id, $item_type, $item_description, $tran_unit, $tran_qty, $base_qty, $conversion_factor, $standard_cost, 
                                               $project_site_id, $line_comment, $task_id, $id, $rtn_line_id);

                if (! ($ln_id > 0)) {
                    return array("success" => false, "message" => "Could not save GRN Line #$id ".$systypes_array[$type]." line details.");
                } 
        
        return array("success" => true, "message" => $systypes_array[$type]." details have been saved.");
}

function save_direct_purchase_returns(&$rcp_no, &$rtn_no, $process=false) {
    global $systypes_array;
    
    $rcp_type = ST_DIRECT_PURCHASE_RECEIPT; $type = ST_DIRECT_PURCHASE_RETURN;
    
    $cn_sv_hd = can_save_direct_purchase_return_header($rcp_no, $rtn_no);   
        if ($cn_sv_hd["success"] !== true) {          
            return $cn_sv_hd;
        }
        
        $rcp_row_state = $cn_sv_hd['rcp_row_state']; $rtn_row_state = $cn_sv_hd['rtn_row_state'];
        
    $rcp_header = get_quality_check_header_record($rcp_no);
        $rcp_trans_no = $rcp_header['trans_no']; $project_id = $rcp_header['project_id'];
        
    $trans_no = 0; 
    $rtn_hd_row = get_quality_check_header_record($rtn_no);
        if (is_array($rtn_hd_row)) {
            $trans_no = $rtn_hd_row['trans_no']; 
        }
        
    $cn_sv_line = can_save_direct_purchase_return_lines($rcp_trans_no, $trans_no, $type, $_POST['location'], $process);   
        if ($cn_sv_line["success"] !== true) {          
            return $cn_sv_line;
        }
        
    $tran_date = date2sql($_POST['tran_date']);
       
        begin_transaction();

            $hd_msg = save_direct_purchase_return_header($rcp_no, $rtn_no, $trans_no, $type, $project_id, $_POST['location'], $tran_date, $rtn_row_state);
                if ($hd_msg["success"] !== true) {
                    cancel_transaction();
                    return array("success" => false, "message" => $hd_msg['message']);
                }
                
            $new_rtn_row_state = db_new_row_state($rtn_row_state);
             
            $rtn_approval_status = AS_NEW;
            
            if ($process === true) {
                $current_user_id = $_SESSION['wa_current_user']->user;
                $task_costs = 0;
                
                $ap_msg = approve_document($rtn_hd_row['type'], $rtn_hd_row['trans_no'], $rtn_hd_row['project_id'], $task_costs, $rtn_hd_row['next_approval_group_id'], 
                                           $current_user_id, $new_rtn_row_state, $rtn_hd_row['created_by']);
                    if ($ap_msg['success'] === false ) {
                        cancel_transaction();
                        return $ap_msg;
                    }
                    
                $rtn_approval_status = $ap_msg["approval_status"];
            }

            $sv_ln_msg = save_direct_purchase_return_lines($rcp_trans_no, $trans_no, $project_id, $tran_date, $_POST['location'], $process, $rtn_approval_status);
                if ($sv_ln_msg['success'] !== true) {
                    cancel_transaction();
                    return $sv_ln_msg;       
                }
            
            // save direct purchase return alloc returned qty => this should be called after lines saving becouse it checks with approval status
            $up_rnt_msg = update_direct_purchase_returns_qty_on_all_parent_tables($rcp_trans_no);
                if ($up_rnt_msg['success'] === false) {
                    cancel_transaction();
                    return $up_rnt_msg;
                }
                
                $dp_req_trans_no = $up_rnt_msg["dp_req_trans_no"];
                $dp_req_approval_status = $up_rnt_msg["dp_req_approval_status"];
                $dp_req_row_state = db_new_row_state($up_rnt_msg["dp_req_row_state"]);
                
            if ($process === true && $rtn_approval_status == AS_APPROVED && $dp_req_trans_no > 0) {
                // update direct purchase requisition approval status from completed to Approved
                if ($dp_req_approval_status == AS_COMPLETED) {
                    $ap_msg2 = direct_update_document_status(ST_DIRECT_PURCHASE_REQ, $dp_req_trans_no, AS_APPROVED, $dp_req_row_state);     
                        if ($ap_msg2['success'] === false ) {
                            cancel_transaction();
                            return array("success" => false, "message" => "Could not update ".$systypes_array[ST_DIRECT_PURCHASE_REQ]." approval status.");
                        }
                }
            }
                
            $rcp_af = update_quality_check_row_state($rcp_type, $rcp_trans_no, $rcp_row_state);
                if (! ($rcp_af > 0)) {
                    cancel_transaction();
                    return array("success" => false, "message" => "Could not update ".$systypes_array[$rcp_type]." record #$rcp_no row state.");
                }
                
        commit_transaction();
            
            if ($process === true) {
                set_session_variable('dp_rtn_messages', $ap_msg['message']);
                meta_forward($_SERVER['PHP_SELF'], "type=$type&ProcessedID=$trans_no");  
            } else {
                return array("success" => true, "message" => $systypes_array[$type]." Trans #$trans_no has been saved.");
            }
}

function process_direct_purchase_return_line($type, $trans_no, $tran_date, $project_id, $loc_code, $rtn_line_id, $stock_control_method) {
    $row = get_quality_check_details_line_by_type_trans_no_line_no($type, $trans_no, $rtn_line_id);
            
        // stock move
        $stk_mv_msg = process_direct_purchase_return_item($trans_no, $type, $tran_date, $project_id, $loc_code, $row);
            if ($stk_mv_msg['success'] === false) {
                cancel_transaction();
                return $stk_mv_msg;
            }
            
        // lot move
        if ($stock_control_method == SKCM_LOTS) {
            $lot_mv_msg = lot_allocations_to_lot_moves($type, $trans_no, $rtn_line_id);
                if ($lot_mv_msg['success'] === false) {
                    cancel_transaction();
                    return $lot_mv_msg;
                }
                
            $lot_loc_array = $lot_mv_msg['lot_loc_array'];
            
            // update lot balances
            $lot_bl_msg = save_lot_balances_from_array($lot_loc_array);
                if ($lot_bl_msg['success'] === false) {
                    cancel_transaction();
                    return $lot_bl_msg;
                }
        }

        return array("success" => true, "message" => "");
}

function process_direct_purchase_return_item($trans_no, $type, $tran_date, $project_id, $loc_code, $row) {
    $tran_date_ = sql2date($tran_date);
    
    $qty = abs($row["qty"]);
    $tran_qty = abs($row["tran_qty"]);
    
    if ($type == ST_DIRECT_PURCHASE_RETURN) {
        $qty *= -1;
        $tran_qty *= -1;
    }
    
    $standard_cost = $row["standard_cost"];
    
        if ($row['mb_flag'] == 'B' || $row['mb_flag'] == 'M') {
            $n = add_stock_adjustment_item($trans_no, $row["stock_id"], $loc_code, $tran_date_, $row["reference"], $qty, $standard_cost, '', $row["tran_unit"], $tran_qty, 
                                           $row["conversion_factor"], $type, $row["task_id"], $row["project_site_id"], $row["trans_id"], $project_id);
        } else {
            $n = add_non_stock_move($type, $row["stock_id"], $trans_no, $loc_code, $tran_date_, $row["reference"], $qty, $standard_cost, '', $row["visible"], $row["price"], 
                                    $row["discount_percent"], $row["tran_unit"], $tran_qty, $row["conversion_factor"], $row["task_id"], $row["project_site_id"], 
                                    $row["trans_id"], $row["item_description"], $project_id);
        }

        if (! ($n > 0)) {
            return array("success" => false, "message" => "Could not create the movement record for rec id : ".$row["trans_id"]);
        }

        return array("success" => true, 'trans_no' => $trans_no, "message" => "");            
}

function can_reject_back_to_originator_direct_purchase_return($rcp_no, $rtn_no, $trans_tp_name, $reject) {
    global $systypes_array;
    
    $req_hd = get_quality_check_header_record($rcp_no);
        if (is_array($req_hd)) {
            if ($req_hd['type'] != ST_DIRECT_PURCHASE_RECEIPT) {
                return array("success" => false, "message" => "Invalid transaction type.");
            }
        } else {
            return array("success" => false, "message" => $systypes_array[ST_DIRECT_PURCHASE_RECEIPT]." #$rcp_no has been deleted by another user.");
        }
    
    $hd_row = get_quality_check_header_record($rtn_no);
    
        if (! is_array($hd_row)) {
            return array("success" => false, "message" => "Could not find $trans_tp_name #$rtn_no.");
        }

        if (! isset($hd_row['type']) || $hd_row['type'] != ST_DIRECT_PURCHASE_RETURN) {
            return array("success" => false, "message" => "Invalid transaction type.");
        }
        
        if ($reject === true) {
            if (! in_array($hd_row['approval_status'], array(AS_NEW, AS_AWAITING_APPROVAL, AS_BACK_TO_ORIGINATOR, AS_WITH_THE_APPROVER))) {
                return array("success" => false, "message" => "This document status does not allow to reject. Only unapproved records can be rejected.");
            }
        } else {
            if (! in_array($hd_row['approval_status'], array(AS_AWAITING_APPROVAL, AS_WITH_THE_APPROVER))) {
                return array("success" => false, "message" => "This document status does not allow to back to originator.");
            }
        }
        
        $ced_msg = can_edit_document(ST_DIRECT_PURCHASE_RETURN, $hd_row['project_id'], $hd_row['next_approval_group_id'], $_SESSION['wa_current_user']->user, 
                                     $hd_row['created_by']);
            if ($ced_msg['success'] !== true) {
                return array("success" => false, "message" => $ced_msg['message']);
            }
        
        return array("success" => true, "message" => "", "req_hd_row" => $req_hd, "hd_row" => $hd_row);
}

function update_direct_purchase_returns_qty_on_all_parent_tables($rcp_trans_no) {
    global $systypes_array;
    
    // update direct purchase receipt: returned qty, return alloc qty
    $sv_rt_qty = save_direct_purchase_receipt_lines_returned_qty_total(ST_DIRECT_PURCHASE_RECEIPT, $rcp_trans_no);
        if ($sv_rt_qty['success'] !== true) {
            cancel_transaction();
            return $sv_rt_qty;
        }

        $qc_line_ids_array = $sv_rt_qty["qc_line_ids_array"];
        
    // update quality check: returned qty, return alloc qty
    foreach ($qc_line_ids_array as $qc_line_id) {
        $cal_up_msg = calculate_and_update_quality_check_line_grn_returned_qty_total($qc_line_id, ST_DIRECT_PURCHASE_RETURN, 0, ST_DIRECT_PURCHASE_RECEIPT);
            if ($cal_up_msg['success'] !== true) {
                cancel_transaction();
                return $cal_up_msg;
            }    
    }
    
    $approval_status = array(AS_NEW, AS_WITH_THE_APPROVER, AS_AWAITING_APPROVAL, AS_BACK_TO_ORIGINATOR, AS_APPROVED, AS_COMPLETED);

    // when quality checing if only added new records wihtout DPR then thre is not any DPR lines 
    $req_id = $dp_req_trans_no = $dp_req_row_state = $dp_req_approval_status = $req_line_row_state = 0;
    $result = get_quality_check_lines_with_direct_purchase_requisitions_by_qc_line_ids($qc_line_ids_array);
        while ($row = db_fetch($result)) {
            $req_id = $row["req_id"];
            $dp_req_trans_no = $row["dp_req_trans_no"];
            $dp_req_row_state = $row["req_row_state"];
            $dp_req_approval_status = $row["dp_req_approval_status"];
            $req_trans_id = $row["req_trans_id"];
            $req_ln_rs = $row["req_line_row_state"];
            
            $upaf_row = update_direct_purchase_requisition_line_column_total_qty($req_trans_id, ST_QUALITY_CHECK, $approval_status, $req_ln_rs, "returned_alloc");
                if ($upaf_row != 1) {
                    cancel_transaction();
                    return array("success" => false, "message" => $systypes_array[ST_DIRECT_PURCHASE_REQ]." Line #$req_trans_id could not update total returned quantity.");  
                }
                
                $req_ln_rs2 = db_new_row_state($req_ln_rs);
                
            $upaf_row2 = update_direct_purchase_requisition_line_column_total_qty($req_trans_id, ST_QUALITY_CHECK, $approval_status, $req_ln_rs2, "returned_quantity");
                if ($upaf_row2 != 1) {
                    cancel_transaction();
                    return array("success" => false, "message" => $systypes_array[ST_DIRECT_PURCHASE_REQ]." Line #$req_trans_id could not update total returned quantity.");  
                }
        }
        
        if ($req_id > 0) {
            $rq_hd_up = update_direct_purchase_requisition_row_state($req_id, $dp_req_row_state);
                if ($rq_hd_up != 1) {
                    cancel_transaction();
                    return array("success" => false, "message" => $systypes_array[ST_DIRECT_PURCHASE_REQ]." Line #$req_trans_id could not update total checked quantity.");  
                }
        }
                    
        return array("success" => true, "message" => "Returned quantities have been updated in all parent tables.", "dp_req_trans_no" => $dp_req_trans_no, 
                     "dp_req_row_state" => $dp_req_row_state, "dp_req_approval_status" => $dp_req_approval_status);  
}

function reject_direct_purchase_return($rcp_no, $rtn_no) {
    global $systypes_array;
    
    $rcp_type = ST_DIRECT_PURCHASE_RECEIPT;
    $type = ST_DIRECT_PURCHASE_RETURN;
    $trans_tp_name = $systypes_array[$type];
    
    $cn_rej = can_reject_back_to_originator_direct_purchase_return($rcp_no, $rtn_no, $trans_tp_name, true);
        if ($cn_rej["success"] !== true) { 
            return $cn_rej;
        } 
        
        $req_hd_row = $cn_rej["req_hd_row"];
            $rcp_row_state = $req_hd_row['row_state'];
            $rcp_trans_no = $req_hd_row["trans_no"];
        
        $hd_row = $cn_rej["hd_row"];
            $trans_no = $hd_row["trans_no"];
            $row_state = $hd_row["row_state"];
        
        begin_transaction();
        
            $rj_msg = reject_document($type, $trans_no, $hd_row['project_id'], $hd_row['next_approval_group_id'], $_SESSION['wa_current_user']->user, $row_state);
                if ($rj_msg['success'] !== true) {
                    cancel_transaction();
                    return array("success" => false, "message" => $rj_msg['message']);
                }
                
            // save direct purchase return alloc returned qty => this should be called after lines saving becouse it checks with approval status
            $up_rnt_msg = update_direct_purchase_returns_qty_on_all_parent_tables($rcp_trans_no);
                if ($up_rnt_msg['success'] === false) {
                    cancel_transaction();
                    return $up_rnt_msg;
                }
                
            $req_af = update_quality_check_row_state($rcp_type, $rcp_trans_no, $rcp_row_state);
                if (! ($req_af > 0)) {
                    cancel_transaction();
                    return array("success" => false, "message" => "Could not update ".$systypes_array[$rcp_type]." trans #$rcp_trans_no row state.");
                }
            
        commit_transaction();

            set_session_variable('dp_rtn_rj_messages', "$trans_tp_name trans #$trans_no has been rejected.");
            meta_forward($_SERVER['PHP_SELF'], "type=$type&RejectedID=$trans_no"); 
}

function back_to_originator_direct_purchase_return($qck_no, $rcp_no) {
    global $systypes_array;
    
    $type = ST_DIRECT_PURCHASE_RETURN;
    $trans_tp_name = $systypes_array[$type];
    
    $cn_rej = can_reject_back_to_originator_direct_purchase_return($qck_no, $rcp_no, $trans_tp_name, false);
        if ($cn_rej["success"] !== true) { 
            return $cn_rej;
        } 
        
        $hd_row = $cn_rej["hd_row"];
        $trans_no = $hd_row["trans_no"];
        
        begin_transaction();
        
            $ap_msg = send_back_to_document_originator($type, $trans_no, $hd_row['project_id'], $hd_row['next_approval_group_id'], $_SESSION['wa_current_user']->user, 
                                                       $hd_row['row_state'], $hd_row['created_by']);
                if ($ap_msg['success'] === false ) {
                    cancel_transaction();
                    return array("success" => false, "message" => $ap_msg['message']);
                }
            
        commit_transaction();

            set_session_variable('dp_rtn_bo_messages', $ap_msg['message']);
            meta_forward($_SERVER['PHP_SELF'], "type=$type&BackedOrgID=$trans_no"); 
}

function view_direct_purchase_return_details($type, $trans_no) {
    global $daily_item_types_array;
    
    $view_tp = ST_LOT_ALLOCATION;
    $hd_row = get_quality_check_header_record_type_trans_no($type, $trans_no);
        if (in_array($hd_row['approval_status'], array(AS_APPROVED))) {
            $view_tp = ST_LOT_MOVE;
        }
        
    $user_id = $_SESSION['wa_current_user']->user;
    $cap = can_access_project($hd_row['project_id'], $user_id);
        if ($cap['success'] !== true) {
            display_error($cap["message"]);
            display_footer_exit();
            exit;
        }
    
    start_table(TABLESTYLE, "width=99%");

        $th = array(_("ID"), _("RCP Line"), _("Item Type"), _("Description"), _("Tran Unit"), _("Tran Qty"), _("Base Unit"), _("Base Qty"), _('Budget'), _('Unit Price'), 
                    _('Project Site'), _('Comment'));  
        table_header($th);

        $k = 0; //row colour counter
            $result = get_quality_check_details($trans_no, $type);      
                while ($row = db_fetch($result)) {
                    $dec = 4;

                    alt_table_row_color($k);

                        $trans_id = $row['trans_id'];
                        
                        if ($row['stock_control_method'] == SKCM_LOTS) {
                            $params = "type=".$type."&trans_no=$trans_no&line_id=$trans_id";
                            label_cell(get_data_view_str($view_tp, $params, $trans_id), 'align=center');
                        } else {
                            label_cell($row['trans_id'], 'align=center');
                        }
                        
                        label_cell($row['source_line_id'], 'align=center');
                        label_cell($daily_item_types_array[$row['item_type']]);
                        if ($row['item_type'] == NSIT_NON_STOCK_ITEM || $row['item_type'] == NSIT_STOCK_ITEM) {
                            label_cell($row["stock_id"]." - ".$row["item_description"]);  
                        } else {
                            label_cell($row["item_description"]);
                        }
                        label_cell($row["unit_name"]);
                        
                        $params = "type=".$type."&trans_no=$trans_no&line_id=$trans_id";
                        if ($row['stock_control_method'] == SKCM_LOTS) {
                            label_cell(get_data_view_str($view_tp, $params, number_format($row["tran_qty"], $dec)), 'align=right');
                        } else {
                            qty_cell($row["tran_qty"], false, $dec);
                        }
                        
                        label_cell(get_item_base_unit_name($row["stock_id"]));
                        if ($row['stock_control_method'] == SKCM_LOTS) {
                            label_cell(get_data_view_str($view_tp, $params, number_format($row["qty"], $dec)), 'align=right');
                        } else {
                            qty_cell($row["qty"], false, $dec);
                        }
                        
                        if ($row['item_type'] == NSIT_COMMENT) {
                            label_cell('No budget required');
                        } else {
                            label_cell($row["task_description"]);
                        }
                        
                        if ($row["standard_cost"] > 0) {
                            qty_cell($row["standard_cost"], false, 2);
                        } else {
                            label_cell('');
                        }
                            
                        label_cell($row["site_description"]);          
                        label_cell(nl2br($row["line_comment"]));          

                    end_row();        
                }

    end_table(2);
}

?>